/*
    AutoX11, a tool to automate tasks in an X11 environment
    Copyright (C) 2014  Alicia <alicia@ion.nu>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <X11/Xlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

extern XImage* getscreenshot(Display* display, int screen);
extern void findneedle(XImage* haystack, GdkPixbuf* needle, void callback(int,int));
extern void typechar(Display* display, wchar_t chr);
extern char* keylist[];
extern void guesskey(const char* key);

#define gdk_r(img,x,y) gdkpixels[(x)*gdkbpp+(y)*gdk_pixbuf_get_rowstride(img)]
#define gdk_g(img,x,y) gdkpixels[(x)*gdkbpp+(y)*gdk_pixbuf_get_rowstride(img)+1]
#define gdk_b(img,x,y) gdkpixels[(x)*gdkbpp+(y)*gdk_pixbuf_get_rowstride(img)+2]

#define x_r(img,x,y) ((unsigned char*)img->data)[(x)*xbpp+(y)*img->bytes_per_line+2]
#define x_g(img,x,y) ((unsigned char*)img->data)[(x)*xbpp+(y)*img->bytes_per_line+1]
#define x_b(img,x,y) ((unsigned char*)img->data)[(x)*xbpp+(y)*img->bytes_per_line]
