/*
    AutoX11, a tool to automate tasks in an X11 environment
    Copyright (C) 2014  Alicia <alicia@ion.nu>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ctype.h>
#include "autox11.h"
#define x // printf("line %i\n", __LINE__)

void guesskey(const char* key)
{
  int closest=0;
  int closestscore=99999;
  int i;
  for(i=0; keylist[i]; ++i)
  {
    int a=0;
    int b=0;
    int score=0;
    while(key[a] || keylist[i][b])
    {
      if(tolower(key[a])==tolower(keylist[i][b])){++a; ++b; continue;}
      if(!key[a]){++score; ++b; x; continue;}
      if(!keylist[i][b]){++score; ++a; x; continue;}
      int skip=1;
      while(1)
      {
//        if(!key[a+skip]){score+=skip; b+=skip; x; break;}
//        if(!keylist[i][b+skip]){score+=skip; a+=skip; x; break;}
        if(!key[a+skip]){++score; ++b; x; break;}
        if(!keylist[i][b+skip]){++score; ++a; x; break;}
        if(tolower(key[a])==tolower(keylist[i][b+skip]))
        {
          b+=skip;
          score+=skip; x;
          break;
        }
        if(tolower(key[a+skip])==tolower(keylist[i][b]))
        {
          a+=skip;
          score+=skip; x;
          break;
        }
        ++skip;
      }
    }
    if(score<closestscore)
    {
      closestscore=score;
      closest=i;
//      printf("'%s', score=%i\n", keylist[i], score);
    }
  }
  if(keylist[closest]){printf("Did you mean: %s?\n", keylist[closest]);}
}
